"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HttpMessage = (function () {
    function HttpMessage() {
        this.headers = [];
        this.httpVersion = "1.1";
        this.isRequest = false;
    }
    HttpMessage.prototype.addHeader = function (headerKey, value) {
        this.headers.push({ "key": headerKey, "value": value });
    };
    HttpMessage.prototype.setStatusCode = function (status) {
        this.statusCode = status;
    };
    HttpMessage.prototype.setStatusText = function (text) {
        this.statusText = text;
    };
    HttpMessage.prototype.setHttpVersion = function (version) {
        this.httpVersion = version;
    };
    HttpMessage.prototype.setHttpMethod = function (method) {
        this.isRequest = true;
        this.httpMethod = method;
    };
    HttpMessage.prototype.setHttpMethodParam = function (param) {
        this.isRequest = true;
        this.httpMethodParam = param;
    };
    HttpMessage.prototype.createMessage = function () {
        var response = "";
        if (this.isRequest) {
            response += this.httpMethod + ' ' + this.httpMethodParam + ' HTTP/' + this.httpVersion;
            response += this.crlf();
        }
        else {
            response += "HTTP/" + this.httpVersion + " ";
            response += this.statusCode.toString() + " " + this.statusText;
            response += this.crlf();
        }
        for (var _i = 0, _a = this.headers; _i < _a.length; _i++) {
            var header = _a[_i];
            response += header["key"] + ": " + header["value"];
            response += this.crlf();
        }
        response += this.crlf();
        return response;
    };
    HttpMessage.prototype.crlf = function () {
        return "\r\n";
    };
    return HttpMessage;
}());
exports.HttpMessage = HttpMessage;
//# sourceMappingURL=http-message.js.map